#ifndef _DATE_H
#define _DATE_H

#include <fstream>
#include <string>

using namespace std;

class Date
{// I: (dYear > 0) && (0 < dMonth <= 12) &&
 //    (0 < dDay <= lastDay(dYear, dMonth))
// friend bool operator==( const Date& lhs, const Date& rhs );
/*friend bool operator==( const Date& lhs, const Date& rhs )
{
   return ( lhs.dYear == rhs.dYear && lhs.dMonth == rhs.dMonth &&
            lhs.dDay == rhs.dDay );
}; // operator==( const Date */
public:
   Date();
   explicit Date( int yp, int mp = 1, int dp = 1 );
   Date( const Date& d );
   ~Date()  {  --objCnt;  };
   
   unsigned int getYear() const;
   unsigned int getMonth() const;
   unsigned int getDay() const;
   void setYear( int ay );
   void setMonth( int am );
   void setDay( int ad );
   Date& forward( long int dd );
   Date& operator+=( long int dd ) {  return forward( dd );  }
   Date& operator++() {  return forward( 1 );  }
   void load( istream& bin );
   void save( ostream& bout ) const;
   
   static bool isValidDate( int ay, int am, int ad );
   static unsigned int getObjCnt()  {  return objCnt;  };
private:
   static unsigned int objCnt;
   
   unsigned int  dYear;
   unsigned char dMonth;
   unsigned char dDay;

   static bool isLeapYear( int y );
   static unsigned int lastDay( int y, int m ); 
}; // Date

   unsigned int Date::objCnt = 0;

struct DateXptn
{
   enum { yearErr, monthErr, dayErr, outOfLimits,
          fileNotOpen, cannotRead, cannotWrite };
   char funcName[100];
   int  errorCode;
   int  errVal1; 
   int  errVal2; 
   int  errVal3;
   Date errDateVal;
   DateXptn( const char* mn, int ec,
             int ev1 = 0, int ev2 = 0, int ev3 = 0 )
      : errorCode(ec), errVal1(ev1), errVal2(ev2), errVal3(ev3)
   {  strncpy( funcName, mn, 99 );  funcName[99] = '\0';  }
   DateXptn( const char* mn, int ec,
             int ev1, const Date& ed )
      : errorCode(ec), errVal1(ev1), errDateVal(ed)
   {  strncpy( funcName, mn, 99 );  funcName[99] = '\0';  }
}; // DateXptn

ostream& operator<<( ostream& tout, const Date& rhs );
bool operator<( const Date& lhs, const Date& rhs );
bool operator>=( const Date& lhs, const Date& rhs );
bool operator==( const Date& lhs, const Date& rhs );
bool operator!=( const Date& lhs, const Date& rhs );
Date operator+( const Date& lhs, int rhs );
Date operator+( int lhs, const Date& rhs );


#endif // _DATE_H
